<template>
  <Form
    class="mt-1"
    @submit="validationForm"
    :validation-schema="schema"
    @invalid-submit="onInvalidSubmit"
  >
    <b-row>
      <b-col cols="12" md="2">
        <!-- Company Logo -->
        <div class="d-flex justify-content-center">
          <div class="image-placeholder">
            <template v-if="previewLogo">
              <img :src="previewLogo" alt="" />
              <div
                v-if="pageType != 'view'"
                class="btn btn-icon rounded-circle img-edit-btn"
                @click="removeImage('logo')"
              >
                <IconTrashImage />
              </div>
            </template>
            <div class="no_image" v-if="!previewLogo">
              <div
                v-if="pageType != 'view'"
                class="btn btn-icon rounded-circle img-add-btn"
                @click="
                  $refs.companyLogo.value = null;
                  $refs.companyLogo.click();
                "
              >
                <IconPlusActive></IconPlusActive>
              </div>
              <div
                v-if="pageType == 'view'"
                class="btn btn-icon rounded-circle img-add-btn-disabled disabled"
              >
                <IconPlusActive></IconPlusActive>
              </div>
            </div>
            <input
              ref="companyLogo"
              type="file"
              class="d-none"
              @input="uploadImage('logo')"
            />
          </div>
        </div>
        <p class="image_title black-color mb-0">Add Company Logo</p>
        <p class="image-size-text">Recommended Size</p>
        <p class="image-size-text">160 x 40 px</p>
        <!-- Company Mono -->
        <div class="d-flex justify-content-center mt-3">
          <div class="image-placeholder">
            <template v-if="previewMonoLogo">
              <img :src="previewMonoLogo" alt="" />
              <div
                v-if="pageType != 'view'"
                class="btn btn-icon rounded-circle img-edit-btn"
                @click="removeImage('comapny_mono')"
              >
                <IconTrashImage />
              </div>
            </template>
            <div class="no_image" v-if="!previewMonoLogo">
              <div
                v-if="pageType != 'view'"
                class="btn btn-icon rounded-circle img-add-btn"
                @click="
                  $refs.comapnyMonoLogo.value = null;
                  $refs.comapnyMonoLogo.click();
                "
              >
                <IconPlusActive></IconPlusActive>
              </div>
              <div
                v-if="pageType == 'view'"
                class="btn btn-icon rounded-circle img-add-btn-disabled disabled"
              >
                <IconPlusActive></IconPlusActive>
              </div>
            </div>
            <input
              ref="comapnyMonoLogo"
              type="file"
              class="d-none"
              @input="uploadImage('comapny_mono')"
            />
          </div>
        </div>
        <p class="image_title black-color mb-0">Add Company Mono</p>
        <p class="image-size-text">Recommended Size</p>
        <p class="image-size-text">40 x 40 px</p>
        <!-- Add Profile Picture -->
        <div class="d-flex justify-content-center mt-3">
          <div class="image-placeholder">
            <template v-if="previewProfiePhoto">
              <img :src="previewProfiePhoto" alt="" />
              <div
                v-if="pageType != 'view'"
                class="btn btn-icon rounded-circle img-edit-btn"
                @click="removeImage('profile')"
              >
                <IconTrashImage />
              </div>
            </template>
            <div class="no_image" v-if="!previewProfiePhoto">
              <div
                v-if="pageType != 'view'"
                class="btn btn-icon rounded-circle img-add-btn"
                @click="
                  $refs.profilePhoto.value = null;
                  $refs.profilePhoto.click();
                "
              >
                <IconPlusActive></IconPlusActive>
              </div>
              <div
                v-if="pageType == 'view'"
                class="btn btn-icon rounded-circle img-add-btn-disabled disabled"
              >
                <IconPlusActive></IconPlusActive>
              </div>
            </div>
            <input
              ref="profilePhoto"
              type="file"
              class="d-none"
              @input="uploadImage('profile')"
            />
          </div>
        </div>
        <p class="image_title black-color mb-0">Add Profile Picture</p>
        <p class="image-size-text">Recommended Size</p>
        <p class="image-size-text">500 x 500 px</p>

        <!-- Signature start -->
        <div class="d-flex justify-content-center mt-3">
          <div class="image-placeholder">
            <template v-if="previewSignature">
              <img :src="previewSignature" alt="" />
              <div
                v-if="pageType != 'view'"
                class="btn btn-icon rounded-circle img-edit-btn"
                @click="removeImage('signature')"
              >
                <IconTrashImage />
              </div>
            </template>
            <div class="no_image" v-if="!previewSignature">
              <div
                v-if="pageType != 'view'"
                class="btn btn-icon rounded-circle img-add-btn"
                @click="
                  $refs.signature.value = null;
                  $refs.signature.click();
                "
              >
                <IconPlusActive></IconPlusActive>
              </div>
              <div
                v-if="pageType == 'view'"
                class="btn btn-icon rounded-circle img-add-btn-disabled disabled"
              >
                <IconPlusActive></IconPlusActive>
              </div>
            </div>
            <input
              ref="signature"
              type="file"
              class="d-none"
              @input="uploadImage('signature')"
            />
          </div>
        </div>
        <p class="image_title black-color mb-0">Add Signature</p>
        <p class="image-size-text">Recommended Size</p>
        <p class="image-size-text">500 x 500 px</p>
      </b-col>
      <b-col cols="12" md="10">
        <div class="card-with-shadow">
          <b-card class="form-card">
            <b-tabs>
              <!-- Tab: Account -->
              <b-tab active>
                <template #title>
                  <IconUsers class="profile-tab-icon" />
                  <span class="d-none d-sm-inline">Account</span>
                </template>
                <hr />
                <b-row>
                  <!-- Field: Username -->
                  <b-col cols="12" md="6" class="">
                    <b-form-group>
                      <TextInput
                        ref="firstInput"
                        name="company_name"
                        label="Company Name"
                        type="text"
                        placeholder="Enter Company Name"
                        :value="CompanyModel.company_name"
                        :disabled="pageType == 'view'"
                        :maxlength="30"
                        :autofocus="true"
                        @change="
                          (e) => {
                            createCompanyCode(e);
                            CompanyModel.company_name = e;
                          }
                        "
                      >
                      </TextInput>
                    </b-form-group>
                  </b-col>
                  <b-col cols="12" md="6" class="">
                    <b-form-group>
                      <TextInput
                        name="company_code"
                        label="Company Code"
                        type="text"
                        :readonly="createNew ? false : true"
                        placeholder="Enter Company Code"
                        :value="CompanyModel.company_code"
                        :disabled="pageType == 'view'"
                        :maxlength="4"
                        @change="(e) => (CompanyModel.company_code = e)"
                      ></TextInput>
                    </b-form-group>
                  </b-col>
                  <b-col cols="12" md="6" class="">
                    <b-form-group label="Company ID" label-for="company_id">
                      <!-- <TextInput
                        name="company_id" 
                        label="Company Code"
                        type="text"
                        placeholder="Auto Generated"
                        :value="CompanyModel.company_id"
                        :disabled="pageType == 'view'"
                        :maxlength="4"
                        autofocus="true"></TextInput> -->
                      <b-form-input
                        :disabled="pageType == 'view'"
                        id="company_id"
                        readonly
                        v-model="CompanyModel.company_id"
                        placeholder="Auto Generated"
                      />
                    </b-form-group>
                  </b-col>
                  <b-col cols="12" md="6" class="">
                    <b-form-group label="User ID" label-for="user_id">
                      <b-form-input
                        :disabled="pageType == 'view'"
                        id="user_id"
                        readonly
                        v-model="CompanyModel.user_id"
                        placeholder="Auto Generated"
                      />
                    </b-form-group>
                  </b-col>
                  <b-col cols="12" md="6" class="">
                    <b-form-group>
                      <TextInput
                        ref="firstInput"
                        name="username"
                        label="User Name"
                        type="text"
                        placeholder="Enter User Name"
                        :value="CompanyModel.username"
                        :disabled="pageType == 'view'"
                        :maxlength="50"
                        @change="(e) => (CompanyModel.username = e)"
                      ></TextInput>
                    </b-form-group>
                  </b-col>
                  <b-col cols="12" md="6" class="">
                    <b-form-group>
                      <TextInput
                        name="email"
                        label="Email ID"
                        type="email"
                        placeholder="Enter Email ID"
                        :value="CompanyModel.email"
                        :disabled="pageType == 'view'"
                        :maxlength="50"
                        @change="(e) => (CompanyModel.email = e)"
                      ></TextInput>
                    </b-form-group>
                  </b-col>
                  <b-col cols="12" md="6" class="">
                    <b-form-group>
                      <ContactInput
                        label="Contact Number"
                        name="phone_number"
                        nameCode="country_code"
                        :options="phoneCodes"
                        :value="CompanyModel.phone_number"
                        :valueCode="CompanyModel.country_code"
                        :disabled="pageType == 'view'"
                        placeholder="Enter Contact Number"
                        @validationUpdate="(e) => (countryCodeValidation = e)"
                        @change="(e) => (CompanyModel.phone_number = e)"
                      ></ContactInput>
                    </b-form-group>
                  </b-col>
                  <b-col cols="12" md="12" class="mb-2 px-0">
                    <div class="accordion collapse-icon collapse-default" role="tablist">
                      <b-card no-body class="overflow-visible fill-card p-0 pt-1">
                        <b-card-header
                          block
                          v-b-toggle="'accordion-1'"
                          header-tag="header"
                          class="pt-0  mr-3"
                          role="tab"
                          data-toggle="collapse"
                        >
                          <b-card-title
                            >Fill Additional
                            <span class="text-red">Information</span></b-card-title
                          >
                        </b-card-header>
                        <b-collapse
                          id="accordion-1"
                          accordion="my-accordion"
                          role="tabpanel"
                        >
                          <div class="w-100 d-block m-0 p-0">
                            <div class=" mb-2">
                              <hr />
                            </div>
                            <!-- Additional Information -->
                            <b-row class="form-card inquiry-form mt-1 custom-form px-1">
                              <b-col cols="12" md="6" class=" custom-date-picker">
                                <b-form-group label="Date of Birth" label-for="dob">
                                  <VDatePicker
                                    class="cursor-context-menu disabled p-0"
                                    :model-value="tempDate"
                                    @dayclick="dobSelected"
                                    title-position="left"
                                    :model-config="{
                                      type: 'string',
                                      mask: 'DD/MM/YYYY',
                                    }"
                                    trim-weeks
                                    :first-day-of-week="2"
                                    :masks="{
                                      weekdays: 'WWW',
                                      L: 'DD/MM/YYYY',
                                    }"
                                  >
                                    <template v-slot="{ togglePopover }">
                                      <div class="flex items-center">
                                        <input
                                          v-model="CompanyModel.dob"
                                          class="custom-datepicker-input w-100 outline-none"
                                          :placeholder="'DD/MM/YYYY'"
                                          :disabled="pageType == 'view'"
                                          @click="togglePopover()"
                                        />
                                      </div>
                                    </template>
                                  </VDatePicker>
                                </b-form-group>
                              </b-col>
                            </b-row>
                            <b-row class="form-card inquiry-form mt-1 custom-form px-1">
                              <b-col cols="12" md="6" class="">
                                <b-form-group
                                  label="Address Line 1"
                                  label-for="address_one"
                                >
                                  <b-form-input
                                    :disabled="pageType == 'view'"
                                    id="address_one"
                                    :state="errors.length > 0 ? false : null"
                                    v-model="CompanyModel.address_one"
                                    placeholder="Enter Address Line 1"
                                    v-capitalize
                                    maxlength="100"
                                  />
                                  <small class="text-danger">{{ errors[0] }}</small>
                                </b-form-group>
                              </b-col>
                              <b-col cols="12" md="6" class="">
                                <b-form-group
                                  label="Address Line 2"
                                  label-for="address_two"
                                >
                                  <b-form-input
                                    :disabled="pageType == 'view'"
                                    id="address_two"
                                    :state="errors.length > 0 ? false : null"
                                    v-model="CompanyModel.address_two"
                                    placeholder="Enter Address Line 2"
                                    v-capitalize
                                    maxlength="100"
                                  />
                                  <small class="text-danger">{{ errors[0] }}</small>
                                </b-form-group>
                              </b-col>
                              <b-col cols="12" md="6" class="">
                                <b-form-group label="Postal Code" label-for="pin">
                                  <b-form-input
                                    :disabled="pageType == 'view'"
                                    id="pin"
                                    :state="errors.length > 0 ? false : null"
                                    v-model="CompanyModel.pin"
                                    placeholder="Enter Postal Code"
                                    maxlength="12"
                                  />
                                  <small class="text-danger">{{ errors[0] }}</small>
                                </b-form-group>
                              </b-col>
                              <b-col cols="12" md="6" class="">
                                <b-form-group label="Area" label-for="area">
                                  <b-form-input
                                    :disabled="pageType == 'view'"
                                    id="area"
                                    :state="errors.length > 0 ? false : null"
                                    v-model="CompanyModel.area"
                                    placeholder="Enter Area"
                                    v-capitalize
                                    maxlength="50"
                                  />
                                  <small class="text-danger">{{ errors[0] }}</small>
                                </b-form-group>
                              </b-col>
                              <b-col cols="12" md="6" class="">
                                <b-form-group label="City" label-for="city">
                                  <b-form-input
                                    :disabled="pageType == 'view'"
                                    id="city"
                                    :state="errors.length > 0 ? false : null"
                                    v-model="CompanyModel.city"
                                    placeholder="Enter City"
                                    v-capitalize
                                    maxlength="50"
                                  />
                                  <small class="text-danger">{{ errors[0] }}</small>
                                </b-form-group>
                              </b-col>
                              <b-col cols="12" md="6" class="">
                                <b-form-group label="State / Province" label-for="state">
                                  <b-form-input
                                    :disabled="pageType == 'view'"
                                    id="state"
                                    v-model="CompanyModel.state"
                                    placeholder="Enter State / Province"
                                    v-capitalize
                                    maxlength="50"
                                  />
                                  <small class="text-danger">{{ errors[0] }}</small>
                                </b-form-group>
                              </b-col>
                            </b-row>
                          </div>
                        </b-collapse>
                      </b-card>
                    </div>
                  </b-col>
                </b-row>
              </b-tab>
              <!-- Tab: Information -->
              <b-tab>
                <template #title>
                  <IconSettings class="profile-tab-icon" />
                  <span class="d-none d-sm-inline">Settings</span>
                </template>
                <hr />
                <b-row>
                  <!-- Field: Setting Table -->
                  <b-col cols="10" md="10">
                    <table class="table table-borderless setting-table">
                      <tbody>
                        <tr>
                          <th>Settings Details</th>
                          <th class="text-center">Web</th>
                          <th class="text-center">Mobile</th>
                        </tr>
                        <tr>
                          <td>
                            <p class="mb-0">Login Based On OTP?</p>
                            <p class="note-text mb-0">
                              Note: Default Login is password based.
                            </p>
                          </td>
                          <td>
                            <b-form-group class="text-center">
                              <b-form-checkbox
                                :disabled="pageType == 'view'"
                                :checked="CompanyModel.otp_based_login_web"
                                name="check-button"
                                inline
                                @change="
                                  checkBoxValueChange($event, 'otp_based_login_web')
                                "
                              >
                              </b-form-checkbox>
                            </b-form-group>
                          </td>
                          <td>
                            <b-form-group class="text-center">
                              <b-form-checkbox
                                :disabled="pageType == 'view'"
                                :checked="CompanyModel.otp_based_login_mobile"
                                name="check-button"
                                inline
                                @change="
                                  checkBoxValueChange($event, 'otp_based_login_mobile')
                                "
                              >
                              </b-form-checkbox>
                            </b-form-group>
                          </td>
                        </tr>
                        <tr
                          v-if="
                            CompanyModel.otp_based_login_web ||
                            CompanyModel.otp_based_login_mobile
                          "
                        >
                          <td>
                            <b-form-group>
                              <div class="demo-inline-spacing">
                                <b-form-checkbox
                                  :disabled="pageType == 'view'"
                                  id="otp_on_mail"
                                  :checked="CompanyModel.otp_on_mail"
                                  name="otp_on_mail"
                                  class="my-0 custome-checkbox-lable-inline"
                                  @change="checkBoxValueChange($event, 'otp_on_mail')"
                                >
                                  OTP On Mail
                                </b-form-checkbox>
                                <b-form-checkbox
                                  :disabled="pageType == 'view'"
                                  id="otp_on_message"
                                  :checked="CompanyModel.otp_on_message"
                                  name="otp_on_message"
                                  class="my-0 custome-checkbox-lable-inline"
                                  @change="checkBoxValueChange($event, 'otp_on_message')"
                                >
                                  OTP On Message
                                </b-form-checkbox>
                              </div>
                            </b-form-group>
                          </td>
                          <td></td>
                          <td></td>
                        </tr>

                        <tr>
                          <td class="setting-td">
                            <p class="mb-0">Login Based On IP Restrication?</p>
                            <p class="note-text mb-0">
                              Note: Select if you want to restrict user login based on IP.
                            </p>
                          </td>
                          <td class="setting-td">
                            <b-form-group class="text-center">
                              <CheckboxInput
                                :class="'custom-control custom-control-inline custom-checkbox'"
                                :isSwitch="false"
                                :disabled="pageType == 'view'"
                                :value="CompanyModel.ip_based_login_web"
                                name="ip_based_login_web"
                                label=""
                                @change="
                                  checkBoxValueChange($event, 'ip_based_login_web')
                                "
                              ></CheckboxInput>
                            </b-form-group>
                          </td>
                          <td class="setting-td">
                            <b-form-group class="text-center">
                              <CheckboxInput
                                :class="'custom-control custom-control-inline custom-checkbox'"
                                :isSwitch="false"
                                :disabled="pageType == 'view'"
                                :value="CompanyModel.ip_based_login_mobile"
                                name="ip_based_login_mobile"
                                label=""
                                @change="
                                  checkBoxValueChange($event, 'ip_based_login_mobile')
                                "
                              ></CheckboxInput>
                            </b-form-group>
                          </td>
                        </tr>
                        <tr
                          v-if="
                            CompanyModel.ip_based_login_web ||
                            CompanyModel.ip_based_login_mobile
                          "
                        >
                          <td>
                            <label>Permitted IP <span class="text-danger">*</span></label>
                            <SelectTagInput class="ip-box"
                              :disabled="pageType == 'view'"
                              v-model="CompanyModel.ip_options"
                              name="ip_options"
                              placeholder="Add IPs"
                            ></SelectTagInput>
                          </td>
                          <td></td>
                          <td></td>
                        </tr>

                        <tr>
                          <td class="setting-td">
                            <p class="mb-0">Auto Logout User?</p>
                            <p class="note-text mb-0">
                              Note: If you want user to auto logout daily.
                            </p>
                          </td>
                          <td class="setting-td">
                            <b-form-group class="text-center">
                              <b-form-checkbox
                                :disabled="pageType == 'view'"
                                :checked="CompanyModel.auto_logout_web"
                                name="check-button"
                                inline
                                @change="checkBoxValueChange($event, 'auto_logout_web')"
                              >
                              </b-form-checkbox>
                            </b-form-group>
                          </td>
                          <td class="setting-td">
                            <b-form-group class="text-center">
                              <b-form-checkbox
                                :disabled="pageType == 'view'"
                                :checked="CompanyModel.auto_logout_mobile"
                                name="check-button"
                                inline
                                @change="
                                  checkBoxValueChange($event, 'auto_logout_mobile')
                                "
                              >
                              </b-form-checkbox>
                            </b-form-group>
                          </td>
                        </tr>
                        <tr
                          v-if="
                            CompanyModel.auto_logout_web ||
                            CompanyModel.auto_logout_mobile
                          "
                        >
                          <td>
                            <label>Auto Logout Time</label>
                            <b-form-group class="auto-logout-group">
                              <b-input-group
                                label="Auto Logout At"
                                label-for="auto_logout_at"
                                :append="logoutTimeZone"
                                class="auto_logout_at"
                              >
                                <b-form-timepicker
                                :hour12="false"
                                  :disabled="pageType == 'view'"
                                  v-model="CompanyModel.auto_logout_at"
                                />
                              </b-input-group>
                            </b-form-group>
                          </td>
                          <td></td>
                          <td></td>
                        </tr>
                      </tbody>
                    </table>
                  </b-col>
                </b-row>
              </b-tab>
            </b-tabs>
          </b-card>
        </div>
        <b-row class="mt-2">
          <b-col cols="12" md="6" class="px-4">
            <div class="d-flex form-status">
              <label class="d-block pt-1 mr-1" for="status"
                >Status <span class="text-danger">*</span></label
              >
              <b-form-checkbox
                :disabled="pageType == 'view'"
                class="status-switch"
                :checked="CompanyModel.status"
                switch
                name="check-button"
                @change="checkBoxValueChange($event, 'status')"
              />
            </div>
          </b-col>
          <b-col cols="12" md="6" class="px-4 text-right">
            <b-button
              v-if="pageType != 'view'"
              class="btn-reset"
              variant="flat-secondary"
              type="button"
              @click.prevent="getModelData"
            >
              Reset
            </b-button>
            <b-button
              class="btn-submit-edit"
              v-if="pageType != 'view'"
              variant="primary"
              type="submit"
            >
              <b-spinner small v-if="isSubmit" />
              Save
            </b-button>
            <b-button
              class="btn-submit-edit"
              v-if="pageType == 'view'"
              variant="primary"
              type="submit"
              @click.prevent="changeMode(CompanyModel.id)"
            >
              <b-spinner small v-if="isSubmit" />
              Edit
            </b-button>
          </b-col>
        </b-row>
      </b-col>
    </b-row>
  </Form>
</template>
<script>
import {
  BImg,
  BCard,
  BTab,
  BTabs,
  BRow,
  BCol,
  BAlert,
  BFormInput,
  BButton,
  BTable,
  BMedia,
  BAvatar,
  BLink,
  BBadge,
  BDropdown,
  BDropdownItem,
  BPagination,
  BFormGroup,
  BForm,
  BCardBody,
  BCardHeader,
  BCardFooter,
  BCardTitle,
  BFormCheckbox,
  BFormRadioGroup,
  BFormCheckboxGroup,
  BDropdownForm,
  BFormTimepicker,
  BFormFile,
  BSpinner,
  VBToggle,
  BCollapse,
  BInputGroup,
} from "bootstrap-vue";
import vSelect from "vue-select";
import Ripple from "vue-ripple-directive";
import store from "@/store";
import companyService from "./service";
import CompanyModel from "./model/company";
import { ref } from "vue";
import flatPickr from "vue-flatpickr-component";
import moment from "moment";
import ToastificationContent from "@core/components/toastification/ToastificationContent.vue";
import countrycode from "@/countrycode.json";
import { useRoute } from "vue-router";
import { useToast } from "vue-toastification";
const toast = useToast();
import * as yup from "yup";
import { Form, useForm, ErrorMessage, Field } from "vee-validate";
import "moment-timezone";
import timeZone from "@/timeZone.json";

export default {
  components: {
    Form,
    BCollapse,
    BImg,
    BTab,
    BTabs,
    BCard,
    BRow,
    BCol,
    BAlert,
    BFormInput,
    BButton,
    BTable,
    BMedia,
    BAvatar,
    BLink,
    BBadge,
    BDropdown,
    BDropdownItem,
    BPagination,
    vSelect,
    BFormGroup,
    BForm,
    BCardBody,
    BCardHeader,
    BCardTitle,
    BFormCheckbox,
    BCardFooter,
    flatPickr,
    BFormRadioGroup,
    BFormCheckboxGroup,
    BDropdownForm,
    BFormTimepicker,
    BFormFile,
    BInputGroup,
    VBToggle,
    BSpinner,
  },
  setup() {
    const MODULE_NAME = "company";
    // Register module
    if (!store.hasModule(MODULE_NAME)) store.registerModule(MODULE_NAME, companyService);

    const router = useRoute();
    return { router };
  },
  data() {
    let tempDate = "";

    return {
      tempDate,
      errors: {},
      pageType: this.$route.meta.type,
      isSubmit: false,
      CompanyModel,
      addAdditionDetails: false,
      createNew: true,
      designationOptions: [],
      roleOptions: [],
      permissionOptions: [],
      selected: [],
      ipOptions: [],
      phoneCodes: [],
      currentLogo: "",
      previewLogo: "",
      currentMonoLogo: "",
      previewMonoLogo: "",
      currentCompanyMono: "",
      previewCompanyMono: "",
      currentProfiePhoto: "",
      previewProfiePhoto: "",
      currentSignature: "",
      previewSignature: "",
      dpconfig: {
        dateFormat: "d/m/Y",
      },
      countryCodeValidation: { minLength: 10, maxLength: 10 },
      logoutTimeZone: "UTC",
    };
  },
  directives: {
    Ripple,
    "b-toggle": VBToggle,
  },
  computed: {
    accordion() {
      return this.$parent.accordion ? `accordion-${this.$parent.collapseID}` : null;
    },
    schema() {
      return yup.object().shape({
        username: yup.string().required("Please enter User Name"),
        company_name: yup.string().required("Please enter Company Name"),
        company_code: yup.string().required("Please enter Company Code"),
        email: yup.string().required("Please enter Email ID").email(),
        country_code: yup.string(),
        phone_number: yup.string("Please enter Contact Number").when(["country_code"], {
          is: (country_code) => {
            return country_code;
          },
          then: (schema) =>
            schema
              .min(
                this.countryCodeValidation.minLength,
                "Contact Number must be at least " +
                  this.countryCodeValidation.minLength +
                  " digits"
              )
              .max(
                this.countryCodeValidation.maxLength,
                "Contact Number must be " +
                  this.countryCodeValidation.maxLength +
                  " digits"
              ),
          otherwise: (schema) => schema,
        }),
        ip_based_login_mobile: yup.boolean(),
        ip_based_login_web: yup.boolean(),
        ip_options: yup
          .array("Please enter Permitted IP")
          .when(["ip_based_login_mobile", "ip_based_login_web"], {
            is: (ip_based_login_mobile, ip_based_login_web) => {
              return ip_based_login_mobile || ip_based_login_web;
            },
            then: (schema) => schema.min(1, "Please enter Permitted IP").of(yup.string()),
            otherwise: (schema) => schema,
          }),
      });
    },
  },
  mounted() {
    var systemTimeZone = Intl.DateTimeFormat().resolvedOptions().timeZone;
    if (timeZone[systemTimeZone] != undefined) {
      this.logoutTimeZone = timeZone[systemTimeZone];
    } else {
      this.logoutTimeZone = systemTimeZone;
    }
    const router = useRoute();
    this.id = router?.params?.id;
    this.getModelData();
  },
  methods: {
    isNumber(e) {
      let char = String.fromCharCode(e.keyCode); // Get the character
      if (/^[0-9]+$/.test(char)) return true;
      // Match with regex
      else e.preventDefault(); // If not match, don't add to input text
    },
    changeMode(id) {
      this.$router.push({ name: "company-edit", params: { id: id } }).then(() => {
        this.getModelData();
      });
    },
    validationForm(values, { setErrors }) {
      if (true) {
        const appLoading = document.getElementById("loading-bg");
        if (appLoading) {
          appLoading.style.display = "block";
        }
        this.isSubmit = true;
        let formData = new FormData();
        formData.append("is_logo", this.previewLogo);
        formData.append("is_mono_logo", this.previewMonoLogo);
        formData.append("is_profile", this.previewProfiePhoto);
        formData.append("is_signature", this.previewSignature);
        formData.append("logo", this.currentLogo);
        formData.append("mono_logo", this.currentMonoLogo);
        formData.append("profile", this.currentProfiePhoto);
        formData.append("signature", this.currentSignature);
        formData.append("company_name", values.company_name);
        formData.append("company_code", values.company_code);
        formData.append("username", values.username);
        formData.append("email", values.email);
        formData.append("country_code", values.country_code);
        formData.append("phone_number", values.phone_number);
        formData.append("dob", CompanyModel.dob);
        formData.append("address_one", CompanyModel.address_one);
        formData.append("address_two", CompanyModel.address_two);
        formData.append("area", CompanyModel.area);
        formData.append("city", CompanyModel.city);
        formData.append("state", CompanyModel.state);
        formData.append("pin", CompanyModel.pin);
        formData.append("ip_options", values.ip_options ? values.ip_options : "");
        formData.append("ip_based_login_web", CompanyModel.ip_based_login_web);
        formData.append("ip_based_login_mobile", CompanyModel.ip_based_login_mobile);
        formData.append("otp_based_login_web", CompanyModel.otp_based_login_web);
        formData.append("otp_based_login_mobile", CompanyModel.otp_based_login_mobile);
        formData.append("auto_logout_web", CompanyModel.auto_logout_web);
        formData.append("auto_logout_mobile", CompanyModel.auto_logout_mobile);
        formData.append("otp_on_mail", CompanyModel.otp_on_mail);
        formData.append("otp_on_message", CompanyModel.otp_on_message);
        formData.append("password_otp_on_mail", CompanyModel.password_otp_on_mail);
        formData.append("save_and_appply_all", false);
        formData.append("password_otp_on_message", CompanyModel.password_otp_on_message);
        formData.append(
          "auto_logout_at",
          this.time_convert(1, CompanyModel.auto_logout_at)
        );
        formData.append("status", CompanyModel.status);
        if (CompanyModel.id) {
          formData.append("id", CompanyModel.id);
        }
        store
          .dispatch("company/save", formData)
          .then((response) => {
            appLoading.style.display = "none";
            if (response.data.status == true) {
              this.$router
                .push({
                  name: "company-list",
                })
                .then(() => {
                  this.showToast(
                    "success",
                    "CheckCircleIcon",
                    response.data.title,
                    response.data.message
                  );
                  this.isSubmit = false;
                });
            } else {
              this.isSubmit = false;
              if (response.data.errors) {
                setErrors(response.data.errors);
              } else {
                this.showToast(
                  "danger",
                  "AlertCircleIcon",
                  response.data.title,
                  response.data.message
                );
              }
              this.isSubmit = false;
            }
          })
          .catch(() => {
            this.isSubmit = false;
            appLoading.style.display = "none";
          });
      }
    },
    dobSelected(e) {
      let selectedDate =
        ("0" + e.day).slice(-2) + "/" + ("0" + e.month).slice(-2) + "/" + e.year;
      let tempDate =
        ("0" + e.month).slice(-2) + "/" + ("0" + e.day).slice(-2) + "/" + e.year;
      if (selectedDate == this.CompanyModel.dob) {
        this.CompanyModel.dob = "";
        this.tempDate = "";
      } else {
        this.CompanyModel.dob = selectedDate;
        this.tempDate = tempDate;
      }
    },
    passwordOtpChange(e, type) {
      if (type == "password_otp_on_mail") {
        CompanyModel.password_otp_on_mail = e;
        if (e == false) {
          CompanyModel.password_otp_on_message = true;
        }
      }
      if (type == "password_otp_on_message") {
        CompanyModel.password_otp_on_message = e;
        if (e == false) {
          CompanyModel.password_otp_on_mail = true;
        }
      }
    },
    checkBoxValueChange(e, type) {
      if (type == "status") {
        this.CompanyModel.status = e;
      }
      if (type == "ip_based_login_web") {
        this.CompanyModel.ip_based_login_web = e;
      }
      if (type == "ip_based_login_mobile") {
        this.CompanyModel.ip_based_login_mobile = e;
      }
      if (type == "otp_based_login_web") {
        this.CompanyModel.otp_based_login_web = e;
        if (CompanyModel.otp_based_login_web == true) {
          this.CompanyModel.otp_on_mail = true;
        }
      }

      if (type == "otp_based_login_mobile") {
        this.CompanyModel.otp_based_login_mobile = e;
        if (CompanyModel.otp_based_login_mobile == true) {
          this.CompanyModel.otp_on_mail = true;
        }
      }

      if (type == "auto_logout_web") {
        this.CompanyModel.auto_logout_web = e;
      }
      if (type == "auto_logout_mobile") {
        this.CompanyModel.auto_logout_mobile = e;
      }

      if (type == "otp_on_mail") {
        this.CompanyModel.otp_on_mail = e;
      }
      if (type == "otp_on_message") {
        this.CompanyModel.otp_on_message = e;
      }
      if (type == "otp_on_mail" || type == "otp_on_message") {
        if (CompanyModel.otp_on_mail == true || CompanyModel.otp_on_message == true) {
          if (
            this.CompanyModel.otp_based_login_mobile == true ||
            this.CompanyModel.otp_based_login_web == true
          ) {
          } else {
            this.CompanyModel.otp_based_login_web = true;
            this.CompanyModel.otp_based_login_mobile = true;
          }
        } else {
          if (CompanyModel.otp_on_mail == false && CompanyModel.otp_on_message == false) {
            this.CompanyModel.otp_based_login_web = false;
            this.CompanyModel.otp_based_login_mobile = false;
          }
        }
      }
    },
    removeImage(type) {
      if (type == "comapny_mono") {
        this.$refs.comapnyMonoLogo.value = null;
        this.currentMonoLogo = "";
        this.previewMonoLogo = "";
      }
      if (type == "logo") {
        this.$refs.companyLogo.value = null;
        this.currentLogo = "";
        this.previewLogo = "";
      }
      if (type == "profile") {
        this.$refs.profilePhoto.value = null;
        this.currentProfiePhoto = "";
        this.previewProfiePhoto = "";
      }
      if (type == "signature") {
        this.$refs.signature.value = null;
        this.currentSignature = "";
        this.previewSignature = "";
      }
    },
    uploadImage(type) {
      if (type == "comapny_mono") {
        this.currentMonoLogo = this.$refs.comapnyMonoLogo.files.item(0);
        this.previewMonoLogo = URL.createObjectURL(this.currentMonoLogo);
      }
      if (type == "logo") {
        this.currentLogo = this.$refs.companyLogo.files.item(0);
        this.previewLogo = URL.createObjectURL(this.currentLogo);
      }
      if (type == "profile") {
        this.currentProfiePhoto = this.$refs.profilePhoto.files.item(0);
        this.previewProfiePhoto = URL.createObjectURL(this.currentProfiePhoto);
      }
      if (type == "signature") {
        this.currentSignature = this.$refs.signature.files.item(0);
        this.previewSignature = URL.createObjectURL(this.currentSignature);
      }
    },
    createCompanyCode(val) {
      if (this.createNew == true) {
        val = val.substr(0, 4);
        this.CompanyModel.company_code = val;
      }
    },
    showToast(variant, icon, title, message) {
      toast({
        component: ToastificationContent,
        props: {
          title: title,
          icon,
          text: message,
          variant,
        },
      });
    },
    getModelData() {
      store
        .dispatch("company/countryCode")
        .then((response) => {
          this.phoneCodes = response.data.result;
        })
        .catch(() => {});
      if (this.id) {
        const appLoading = document.getElementById("loading-bg");
        if (appLoading) {
          appLoading.style.display = "block";
        }
        store
          .dispatch("company/edit", { id: this.id })
          .then((response) => {
            (this.pageType = this.$route.meta.type), (this.createNew = false);
            const data = response.data.result;
            this.CompanyModel.id = data.id;
            this.CompanyModel.company_id = data.company_id;
            this.CompanyModel.company_name = data.name;
            this.CompanyModel.company_code = data.company_code;
            this.CompanyModel.country_code = data.country_code;
            this.CompanyModel.phone_number = data.phone_number;
            this.CompanyModel.address_one = data.address_one ? data.address_one : "";
            this.CompanyModel.address_two = data.address_two ? data.address_two : "";
            this.CompanyModel.area = data.area ? data.area : "";
            this.CompanyModel.city = data.city ? data.city : "";
            this.CompanyModel.state = data.state ? data.state : "";
            this.CompanyModel.pin = data.pin ? data.pin : "";
            this.CompanyModel.ip_based_login_mobile =
              data.ip_based_login_mobile == 1 ? true : false;
            this.CompanyModel.ip_based_login_web =
              data.ip_based_login_web == 1 ? true : false;
            this.CompanyModel.otp_based_login_mobile =
              data.otp_based_login_mobile == 1 ? true : false;
            this.CompanyModel.otp_based_login_web =
              data.otp_based_login_web == 1 ? true : false;
            this.CompanyModel.auto_logout_mobile =
              data.auto_logout_mobile == 1 ? true : false;
            this.CompanyModel.auto_logout_web = data.auto_logout_web == 1 ? true : false;
            this.CompanyModel.otp_on_mail = data.otp_on_mail == 1 ? true : false;
            this.CompanyModel.otp_on_message = data.otp_on_message == 1 ? true : false;
            this.CompanyModel.password_otp_on_mail =
              data.password_otp_on_mail == 1 ? true : false;
            this.CompanyModel.password_otp_on_message =
              data.password_otp_on_message == 1 ? true : false;
            this.CompanyModel.status = data.status == 1 ? true : false;
            this.CompanyModel.ip_options = data.ip_options ? data.ip_options : "";
            this.CompanyModel.auto_logout_at = this.time_convert(2, data.auto_logout_at);
            if (data.user) {
              const user = data.user;
              this.CompanyModel.user_id = user.user_id;
              this.CompanyModel.username = user.name;
              this.CompanyModel.email = user.email;
              this.CompanyModel.dob = user.dob
                ? moment(user.dob).format("DD/MM/YYYY")
                : "";
              this.tempDate = user.dob;
            }
            if (data.logo) {
              this.previewLogo = data.logo ? import.meta.env.VITE_API_URL + data.logo : "";
            } else {
              this.previewLogo = "";
            }
            if (data.mono_logo) {
              this.previewMonoLogo = data.mono_logo
                ? import.meta.env.VITE_API_URL + data.mono_logo
                : "";
            } else {
              this.previewMonoLogo = "";
            }
            if (data.profile) {
              this.previewProfiePhoto = data.profile
                ? import.meta.env.VITE_API_URL + data.profile
                : "";
            } else {
              this.previewProfiePhoto = "";
            }
            if (data.signature) {
              this.previewSignature = import.meta.env.VITE_API_URL + data.signature;
            } else {
              this.previewSignature = "";
            }
            appLoading.style.display = "none";
          })
          .catch((error) => {
            appLoading.style.display = "none";
          });
      } else {
        (this.CompanyModel.id = ""),
          (this.CompanyModel.company_name = ""),
          (this.CompanyModel.company_code = ""),
          (this.CompanyModel.company_id = ""),
          (this.CompanyModel.user_id = ""),
          (this.CompanyModel.username = ""),
          (this.CompanyModel.email = ""),
          (this.CompanyModel.country_code = "+91"),
          (this.CompanyModel.phone_number = ""),
          (this.CompanyModel.dob = ""),
          (this.CompanyModel.address_one = ""),
          (this.CompanyModel.address_two = ""),
          (this.CompanyModel.area = ""),
          (this.CompanyModel.city = ""),
          (this.CompanyModel.state = ""),
          (this.CompanyModel.pin = ""),
          (this.CompanyModel.ip_options = []),
          (this.CompanyModel.ip_based_login_web = false),
          (this.CompanyModel.ip_based_login_mobile = false),
          (this.CompanyModel.otp_based_login_web = false),
          (this.CompanyModel.otp_based_login_mobile = false),
          (this.CompanyModel.auto_logout_web = false),
          (this.CompanyModel.auto_logout_mobile = false),
          (this.CompanyModel.otp_on_mail = false),
          (this.CompanyModel.otp_on_message = false),
          (this.CompanyModel.password_otp_on_mail = true),
          (this.CompanyModel.password_otp_on_message = false),
          (this.CompanyModel.auto_logout_at = "00:00"),
          (this.CompanyModel.status = true);
        this.previewLogo = "";
        this.previewMonoLogo = "";
        this.previewProfiePhoto = "";
        this.previewSignature = "";
      }
    },
    time_convert(type, time) {
      if (type == 1) {
        var customTime = new Date("2023-07-14T" + time);
        var timeZone = Intl.DateTimeFormat().resolvedOptions().timeZone;
        const Time = moment.tz(customTime, timeZone).utc().format("HH:mm:ss");
        return Time;
      }
      if (type == 2) {
        var utc = new Date("2023-07-13T" + time + "Z");
        var timeZone = Intl.DateTimeFormat().resolvedOptions().timeZone;
        return moment.utc(utc).tz(timeZone).format("HH:mm:ss");
      }
    },
  },
};
</script>

<style lang="scss" scoped>
.per-page-selector {
  width: 90px;
}
</style>

<style lang="scss">
// @import "~@resources/scss/vue/libs/vue-select.scss";
</style>
